# -*- coding: iso-8859-15 -*-
#
#       sport_client.py
#       
#       CopyLeft 2010 aztk <aztecaymaya@gmail.com>
#       
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#       
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#       
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.
#
# sport_client.py 9999 COM1 9600 8 N 1 1 0 0
#
# In conjunction with *. m functions, this program allows the communication
#  of a device connected to a serial port with Octave.
# This communication is accomplished with a serial port control with
#  pySerial library (http://pyserial.sourceforge.net/) in python, and
#  information transmitted python-octave and vice versa through sockets.
# This program serves as the client, while the functions in Octave are the server.

import socket # Required to communicate with sockets
import serial # Required to communicate with serial port
import sys # Required to treat arguments

print 'Welcome to octave-serialport (for Windows)'

addr_socket = int(sys.argv[1]); print 'Address socket: ',addr_socket;
s = socket.socket()
while True:
	try:
		s.connect(('localhost',addr_socket))
		print 'Established connection to port ',addr_socket;
		break
	except socket.error:
		print 'Wait...'

addr_sport = sys.argv[2]
baudr = int(sys.argv[3])

try: # Try to open serial port
	sport = serial.Serial(addr_sport,baudr)
	s.send('%stok%')
except serial.serialutil.SerialException: # If it fails, exit
	s.send('%sper%')
	print 'ERROR: Serial port busy or no exists';
	sys.exit(3)
print 'Open port: ',sport;

sport.bytesize = int(sys.argv[4]);
sport.parity = sys.argv[5]
sport.stopbits = int(sys.argv[6])
sport.xonoff = int(sys.argv[8])
sport.rtscts = int(sys.argv[9])
if sys.argv[7] != 'None': sport.timeout = float(sys.argv[7]);

while True: # Infinite loop
	inputx = s.recv(231); orderx = inputx[:6]; datax = inputx[6:];
	if orderx == '%writ%': # Wtite data from server (octave) to serial port
		sport.write(datax[:-1])
		print 'To serial port:',map(lambda x: ord(x), datax[:-1]);
	elif orderx == '%read%': # Read 'datax' elements from serial port buffer, and sent they to the Server (octave)
		if len(datax): # datax must have length 1
			read_n_elements = ord(datax)
		else:
			read_n_elements = 0
		#read_n_elements = ord(datax)
		data_from_sport = sport.read(read_n_elements)
		print 'From serial port:',map(lambda x: ord(x), data_from_sport);
		n_real_data = len(data_from_sport)
		data_from_sport += (read_n_elements-n_real_data)*chr(0) # If there is a timeout, filled with garbage the vector info
		s.send(chr(n_real_data)) # Send the real number of elements
		s.send(data_from_sport) # Send info
	elif orderx == '%byav%': # Send to the Server (octave) the number of available elements  
		elements_to_read = sport.inWaiting()
		s.send(chr(elements_to_read))
		print 'Bytes Available:',elements_to_read;
	elif orderx == '%clos%': # Finish comunication, and serial port closed
		s.close()
		sport.close()
		print 'Close port:',addr_sport;
		print ' ';
		print 'aztk CopyLeft 2010';
		sys.exit(0)
	else:
		print 'ERROR: Unknown command';

# Author: aztk <aztecaymaya@gmail.com>