# Comunicación puerto serie - Octave
# aztk CopyLeft 2010
#
# data = spwrite(sp,n_elements)
#   Manda una instrucción para leer 'n_elements' elementos
#    del puerto serie 'sp', los recibe y los deposita en el vector
#    'data'. El máximo de elementos a leer es de 255

function data=spread(sp,n_elements)
    if !n_elements % si el numero de elementos a leer es cero, regresar nada
    	data = [];
    	break
    endif
    send(sp.streamAddress,['%read%',char(n_elements)]); % envio de orden de lectura
    %data = [recv(sp, 255, MSG_DONTWAIT)];
    elements_in = recv(sp.streamAddress,1); % numero de elementos reales del puerto serie
       % Si el puerto serie es configurado con timeout, y no hay elementos suficientes en el buffer,
       %  de todos modos el servidor enviará 'n_elements' elementos, pero solo los primeros
       %  'elements_in' son reales.
    data = [recv(sp.streamAddress, n_elements)];
    if elements_in
    	data = data(1:elements_in);
    else
    	data = []; % Si no hay elementos, regresar un vector vacío
    endif
    if elements_in < n_elements % Si el numero de elementos reales es menor
    	warning('serial port timeout') %  al numero de elementos solicitados,
    endif  % arrojar una advertencia
endfunction

# Author: aztk <aztecaymaya@gmail.com>